"""Module for Confirmation Wizard"""
from odoo import fields, models


class ConfirmationWizard(models.TransientModel):
    """Confirmation Wizard"""

    _name = "confirmation.wizard"
    _description = "Confirmation Wizard"

    message = fields.Text("Message", readonly=True)
    model = fields.Char("Model Name", readonly=True)
    method = fields.Char("Method Name", readonly=True)
    res_id = fields.Integer("Record ID", readonly=True)

    def action_confirm(self):
        """Execute the method of the model"""
        record = self.env[self.model].browse(self.res_id)
        if hasattr(record, self.method):
            return getattr(record, self.method)()
        return {"type": "ir.actions.act_window_close"}

    def action_cancel(self):
        """Close the wizard"""
        return {"type": "ir.actions.act_window_close"}
