from odoo import _, api, fields, models
from odoo.exceptions import ValidationError


class ResTarjeta(models.Model):
    _name = "res.tarjeta"
    _description = "model res tarjeta"

    name = fields.Char(string="Name")
    code = fields.Integer(string="Code")
    type = fields.Selection(
        [("credit", "Credit"), ("debit", "Dedit")], string="Card Type"
    )
    shopin = fields.Char(string="Shopin")
    codglamit = fields.Char(string="Codglamit")

    @api.constrains("name", "code", "type")
    def _validate_tar(self):
        """Validation to not enter duplicate cards."""
        res = self.env["res.tarjeta"].search(
            [
                ("name", "=", self.name),
                ("code", "=", self.code),
                ("type", "=", self.type),
            ]
        )
        if len(res) > 1:
            raise ValidationError(_("The card has already been entered"))
