"""Model to classify stock based on turnover"""
from odoo import fields, models


class StockClassification(models.Model):
    """Model to classify stock based on turnover"""

    _name = "stock.classification.rotation"
    _description = "Stock Classification Rotation"

    datatime_created = fields.Datetime(
        string="Created Date", default=fields.Datetime.now
    )
    product_template_id = fields.Many2one(
        "product.template", string="Product Template", required=True
    )
    product_id = fields.Many2one(
        "product.product", string="Product Variant", required=True
    )
    classification_type = fields.Selection(
        [
            ("active", "Active"),
            ("new", "New"),
            ("no_sales", "No Sales"),
            ("dormant", "Dormant"),
        ],
        string="Classification",
        required=True,
        help="Classification of the product or product variant based on turnover",
    )
    company_id = fields.Many2one("res.company", string="Company", required=True)
