"""This module contains the definition of the ResCurrencyRate model."""

from odoo import models


class ResCurrencyRate(models.Model):
    """This class extends the res.currency model to add additional methods."""

    _inherit = "res.currency.rate"

    def write(self, vals):
        """Change supplierinfo inverse rate when this record is changed"""
        res = super(ResCurrencyRate, self).write(vals)
        currency = self.currency_id or vals.get("currency_id", False)
        if currency and currency != self.env.ref("base.ARS"):
            if vals.get("inverse_company_rate", False):
                self.env["product.supplierinfo"].search(
                    [
                        ("currency_id", "=", currency.id),
                    ]
                )._compute_inverse_company_rate()
        return res
