from odoo import fields, models


class StockMove(models.Model):

    _inherit = "stock.move"

    lotes_ids = fields.Many2many(
        "stock.production.lot", string="Número/s de Serie", compute="get_lotes"
    )
    validator = fields.Boolean(string="Validator", compute="compute_validator")

    def get_lotes(self):
        lotes = []
        for rec in self:
            move_line_objects = self.env["stock.move.line"].search(
                [
                    ("product_id", "=", rec.product_id.id),
                    ("picking_id", "=", rec.picking_id.id),
                ]
            )
            for ml in move_line_objects:
                if rec.product_id.id == ml.product_id.id:
                    lotes.append(ml.lot_id.id)
                    rec.write({"lotes_ids": [(4, ml.lot_id.id)]})

    def compute_validator(self):
        for rec in self:
            move_line_objects = self.env["stock.move.line"].search(
                [
                    ("product_id", "=", rec.product_id.id),
                    ("picking_id", "=", rec.picking_id.id),
                ]
            )
            for line in move_line_objects:
                if line.product_id.tracking == "serial":
                    rec.validator = True
                else:
                    rec.validator = False
