"""This module contains the custom implementation of the `sale.order.line` model."""
from odoo import models


class SaleOrderLine(models.Model):
    """Added method for AccountSalesAnalysis line deletion"""

    _inherit = "sale.order.line"

    def clean_sale_analysis_lines(self):
        """Searches for the lines of the AccountSalesAnalysis related to the recordset and deletes them."""
        self.env["account.sales.analysis"].search(
            [("sale_order_line_id", "in", self.ids)]
        ).unlink()
