"""Test cases for sale lost reason model."""
from odoo.exceptions import Exception, ValidationError
from odoo.tests.common import TransactionCase


class TestSaleLostReason(TransactionCase):
    """Test cases for sale lost reason model."""

    def setUp(self):
        """Create a sale lost reason"""
        super().setUp()
        self.sale_lost_reason = self.env["sale.lost.reason"].create(
            {
                "name": "Test Reason",
                "sequence": 10,
            }
        )

    def test_check_name_unique(self):
        """Test that the name field is unique."""
        with self.assertRaises(Exception):
            self.env["sale.lost.reason"].create(
                {
                    "name": "Test Reason",
                    "sequence": 10,
                }
            )

    def test_check_name_not_empty(self):
        """Test that the name field is not empty."""
        with self.assertRaises(ValidationError):
            self.env["sale.lost.reason"].create(
                {
                    "name": "",
                    "sequence": 10,
                }
            )
