"""Test Sale Order Lost"""
from odoo.tests import common


class TestSaleOrderLost(common.TransactionCase):
    """Test cases for sale order lost model."""

    def setUp(self):
        """Create a sale order lost"""
        super().setUp()
        self.sale_order_lost = self.env["sale.order.lost"].create(
            {
                "create_order": "2022-01-01",
                "team_id": self.env.ref("crm.crm_team_sales_department").id,
                "name": "SO001",
                "user_id": self.env.ref("base.user_demo").id,
                "partner_id": self.env.ref("base.res_partner_1").id,
                "order_line_product_name": "Product A",
                "product_code": "ABC123",
                "product_id": self.env.ref("product.product_product_1").id,
                "product_tmpl_id": self.env.ref("product.product_template_1").id,
                "product_uom_qty": 10,
                "sale_lost_reason_id": self.env.ref("sale_lost_reason.reason_1").id,
                "sale_lost_reason_obs": "Lost due to price",
                "currency_id": self.env.ref("base.USD").id,
            }
        )

    def test_total_price(self):
        """Test the total_price field."""
        self.assertEqual(self.sale_order_lost.total_price, 0.0)

    def test_standard_price_total(self):
        """Test the standard_price_total field."""
        self.assertEqual(self.sale_order_lost.standard_price_total, 0.0)

    def test_price_total(self):
        """Test the price_total field."""
        self.assertEqual(self.sale_order_lost.price_total, 0.0)
