from odoo import fields, models
from odoo.addons.payment_pay_way.models.payway_library import PAYWAY_METHODS
from odoo.exceptions import UserError

import requests
import json


import logging

_logger = logging.getLogger(__name__)


class PaymentToken(models.Model):
    _inherit = 'payment.token'

    payway_payment_method = fields.Selection(PAYWAY_METHODS)
    payway_bin = fields.Char()
    payway_instalment = fields.Integer(default=1)

    def payway_require_token(self):
        self.ensure_one()
        api_url = self.provider_id.payway_get_base_url() + '/tokens'
        headers = self.provider_id.payway_get_headers()
        payload = {
            'token': self.provider_ref
        }
        payload = json.dumps(payload, indent=None)
        response = requests.post(api_url, data=payload, headers=headers)
        if response.status_code == 200:
            return response.json()
        else:
            _logger.error(response.text)
            raise UserError("No puedo generar el token de pago")
