# -- coding: utf-8 --
##############################################################################
#
#   Copyright (c) 2022-2025 Eynes SRL (Eynes - Ingenieria del software)
#   License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).
#
##############################################################################

import logging
from odoo import models, fields, _, api

_logger = logging.getLogger(__name__)


class IrUiMenu(models.Model):
    _inherit = 'ir.ui.menu'

    def _load_menus_blacklist(self):
        res = super()._load_menus_blacklist()

        user = self.env.user
        groups = user.has_group

        franchisee_or_seller = groups('sia_custom_permission.group_sia_franchisees') or groups(
            'sia_custom_permission.group_sia_sellers')
        has_admin_permission = franchisee_or_seller or groups('sia_custom_permission.group_sia_administratives')

        if franchisee_or_seller:
            res.append(self.env.ref('spreadsheet_dashboard.spreadsheet_dashboard_menu_configuration').id)

        if has_admin_permission:
            menu_refs = ['website.menu_website_global_configuration', 'website.menu_site',
                         'website_sale.menu_ecommerce', 'website.menu_reporting']
            res.extend(self.env.ref(menu).id for menu in menu_refs)

        return res
